%define major 6
%define libname %mklibname ffi %{major}
%define devname %mklibname ffi -d
%define staticname %mklibname ffi -d -s

Summary:	A portable foreign function interface library
Name:		libffi
Version:	3.1
Release:	5
Group:		System/Libraries
License:	BSD
Url:		http://sourceware.org/%{name}
Source0:	ftp://sourceware.org/pub/%{name}/%{name}-%{version}.tar.gz
Patch0:		libffi-3.1-fix-include-path.patch

%description
Compilers for high level languages generate code that follow certain
conventions. These conventions are necessary, in part, for separate
compilation to work. One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function. A
calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call a
given function. `Libffi' can be used in such programs to provide a
bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions. This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface. A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. The
`libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface. A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	A portable foreign function interface library
Group:		System/Libraries

%description -n %{libname}
Compilers for high level languages generate code that follow certain
conventions. These conventions are necessary, in part, for separate
compilation to work. One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function. A
calling convention also specifies where the return value for a function
is found.

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call a
given function. `Libffi' can be used in such programs to provide a
bridge from the interpreter program to compiled code.

The `libffi' library provides a portable, high level programming
interface to various calling conventions. This allows a programmer to
call any function specified by a call interface description at run time.

FFI stands for Foreign Function Interface. A foreign function
interface is the popular name for the interface that allows code
written in one language to call code written in another language. The
`libffi' library really only provides the lowest, machine dependent
layer of a fully featured foreign function interface. A layer must
exist above `libffi' that handles type conversions for values passed
between the two languages.

%files -n %{libname}
%{_libdir}/libffi.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{devname}
Summary:	Development files for %{name}
Group:		Development/C
Requires:	%{libname} = %{EVRD}
Provides:	ffi-devel = %{EVRD}
Conflicts:	%{_lib}ffi5-devel < 3.1-3
Obsoletes:	%{_lib}ffi5-devel < 3.1-3

%description -n %{devname}
This package contains libraries and header files for developing
applications that use %{name}.

%files -n %{devname}
%doc LICENSE README
%{_libdir}/pkgconfig/libffi.pc
%{_includedir}/ffi*.h
%{multiarch_includedir}/ffi.h
%{_libdir}/libffi.so
%{_mandir}/man3/*
%{_infodir}/libffi.info.*

#----------------------------------------------------------------------------

# The static libffi is used to link Host Dalvik while building
# Android from source - please don't remove it.
%package -n %{staticname}
Summary:	Static libraries for %{name}
Group:		Development/C
Requires:	%{devname} = %{EVRD}
Provides:	ffi-static-devel = %{EVRD}

%description -n %{staticname}
This package contains static libraries for developing
applications that use %{name}.

%files -n %{staticname}
%{_libdir}/*.a

#----------------------------------------------------------------------------

%prep
%setup -q
%apply_patches

%build
%configure2_5x --enable-static
%make

%install
%makeinstall_std
%multiarch_includes %{buildroot}%{_includedir}/ffi.h

sed -i s,"\$(libdir)","\${libdir}",g %{buildroot}%{_libdir}/pkgconfig/libffi.pc

%changelog
* Tue Aug 05 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.1-5
+ Revision: 90ed52d
- Fix pkgconfig file


